package com.zipcodewilmington.arrayutility;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility<E> {

    private E[] array;

    public ArrayUtility(E[] array){
        this.array = array;
    }

    public Integer countDuplicatesInMerge(E[] arrayToMerge, E valueToEvaluate) {
        int counter = 0;
        for(E e: this.array){
            if(valueToEvaluate.equals(e)){
                counter++;
            }
        }
        for(E e: arrayToMerge){
            if(valueToEvaluate.equals(e)){
                counter++;
            }
        }
        return counter;
    }

    public Integer getNumberOfOccurrences(E valueToEvaluate) {
        Integer counter = 0;
        for (E e: this.array) {
            if(e.equals(valueToEvaluate)){
                counter++;
            }
        }
        return counter;
    }

    public E getMostCommonFromMerge(E[] arrayToMerge) {
        HashMap<E,Integer> bin = new HashMap<E,Integer>();

        for (E e: this.array) {
            if(bin.containsKey(e)){
                bin.put(e ,bin.get(e) + 1);
            } else {
                bin.put(e, 1);
            }
        }

        Map.Entry<E, Integer> i = null;

        for (Map.Entry<E, Integer> entry: bin.entrySet()) {
            if (i == null || entry.getValue() > i.getValue()){
                i = entry;
            }
        }

        return i.getKey();
    }

    public E[] removeValue(E valueToRemove) {

        int valCounter = 0;
        for(E e: this.array){
            if(e.equals(valueToRemove)){
                valCounter++;
            }
        }

        E[] withoutValue = Arrays.copyOf(this.array, this.array.length - valCounter);

        int index = 0;

        for(int i = 0; i < this.array.length; i++){
            if(!this.array[i].equals(valueToRemove)){
                withoutValue[index] = this.array[i];
                index++;
            }
        }

        return withoutValue;

    }


}
